<?php

//This is a script for ajax POST from inside_admin, which returns result of component or template evaluating.
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

include_once($ADMIN_FOLDER."function.inc.php");
require_once($INCLUDE_FOLDER."s_extract.inc.php");
//    NetCat       


global $db;
#   
$SETNEWLANG = $nc_core->input->fetch_get_post('NEW_AUTH_LANG');


#   
if (preg_match("/^\w+$/", $AUTH_LANG)) {
  require_once($ADMIN_FOLDER."lang/".$AUTH_LANG.".php");
}
elseif (preg_match("/^\w+$/", $PHP_AUTH_LANG)) {
  require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
}
elseif (preg_match("/^\w+$/", $_SESSION['User']['PHP_AUTH_LANG'])) {
    require_once($ADMIN_FOLDER."lang/".$_SESSION['User']['PHP_AUTH_LANG'].".php");
}
else {
    if (!$PHP_AUTH_LANG) {
      $PHP_AUTH_LANG = NetCat_language_detect();
    }
    if ($PHP_AUTH_LANG && preg_match("/^\w+$/", $PHP_AUTH_LANG) ) {
      require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
    }
    else if ( preg_match("/^\w+$/", $ADMIN_LANGUAGE) )  {
      require_once($ADMIN_FOLDER."lang/".$ADMIN_LANGUAGE.".php");
    }
    else {
      die("Failed to determine language");
    }
}


header("Content-Encoding: ".MAIN_ENCODING);

function check_eval($value,$way=1)
{
  $isDebug=0;
  if (get_magic_quotes_gpc()) {
    $value=stripslashes($value);
  }
  $data = "way=$way&value=".urlencode($value);
  $context_options = array (
        'http' => array (
            'method' => 'POST',
            'header'=> "Content-type: application/x-www-form-urlencoded\r\n"
                ."Content-Length: " . nc_strlen($data) . "\r\n"."Cookie: " . $_SERVER['HTTP_COOKIE']."\r\n",
            'content' => $data
            )
        );
  // ."Cookie: " . $_SERVER['HTTP_COOKIE']."\r\n"
  $context = stream_context_create($context_options);
  $url = "http://".$_SERVER['HTTP_HOST'].join("/",array_slice(split("/",$_SERVER['REQUEST_URI']),0,-1))."/debug_eval.php";
  $buffer = file_get_contents($url,false,$context);
  $buffer = (!$isDebug?strip_tags($buffer):$buffer);
  // TODO:  .
  if ($isDebug==1)echo $buffer."<br/>";
  if ( nc_preg_match("/eval\(\)'d code on line (\d+)/m", $buffer,$match) ) { return $match[1]; }
  //if ( preg_match("/eval\(\)'d code\<\/b\> on line \<b\>(\d)\<\/b>/m", $buffer,$match) ) { return $match[1]; }
  else return 0;
}


//       eval   
$buffer = ob_get_clean();
$output ="<table id=\'debuginfo\'><tbody>";

$status = 0; //   ;

if ($ClassID>0)
//     
{
  switch ($phase)
  {
    //   
    // FormPrefix, RecordTemplate, FormSuffix, RecordTemplateFull,
    // Settings, CustomSettings, RecordsPerPage, SortBy, TitleTepmlate
    case 5:
      $res=check_eval($FormPrefix,1);
      $status=$res?1:$status;
      $output.="<tr> <td>".CONTROL_CLASS_CLASS_OBJECTSLIST_PREFIX."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
      $res=check_eval($RecordTemplate,1);
      $status=$res?1:$status;
      $output.="<tr> <td>".CONTROL_CLASS_CLASS_OBJECTSLIST_BODY."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
      $res=check_eval($FormSuffix,1);
      $status=$res?1:$status;
      $output.="<tr> <td>".CONTROL_CLASS_CLASS_OBJECTSLIST_SUFFIX."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
      $res=check_eval($RecordTemplateFull,1);
      $status=$res?1:$status;
      $output.="<tr> <td>".CONTROL_CLASS_CLASS_OBJECTVIEW."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
      $res=check_eval($Settings,0);
      $status=$res?1:$status;
      $output.="<tr> <td>".CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_SYSTEM."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
      $res=check_eval($CustomSettingsTemplate,0);
      $status=$res?1:$status;
      $output.="<tr> <td>".CONTROL_CLASS_CUSTOM_SETTINGS_TEMPLATE."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";

      break;
    //    :
    case 9:
      switch($myaction)
      {
        //    AddTemplate ,   AddCond ,    AddActionTemplate.
        case 1:
         $res=check_eval($AddTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_ADDFORM."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($AddCond,0);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_ADDRULES."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($AddActionTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_ADDLASTACTION."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         break;
        //    EditTemplate,  EditCond,   EditActionTemplate,   / CheckActionTemplate,    DeleteActionTemplate
        case 2:
         $res=check_eval($EditTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_EDITFORM."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($EditCond,0);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_EDITRULES."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($EditActionTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_EDITLASTACTION."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($CheckActionTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_ONONACTION."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";

         break;
        //      FullSearchTemplate,       SearchTemplate.
        case 3:
         $res=check_eval($FullSearchTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_QSEARCH."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($EditSearchTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_SEARCH."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";

         break;
        //    SubscribeCond,     SubscribeTemplate
        case 4:
         $res=check_eval($SubscribeCond,0);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_MAILRULES."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($SubscribeTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_MAILTEXT."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         break;
        case 5:
         $res=check_eval($DeleteTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_DELETEFORM."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($DeleteCond,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_DELETERULES."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         $res=check_eval($DeleteActionTemplate,1);
         $status=$res?1:$status;
         $output.="<tr> <td>".CONTROL_CLASS_CLASS_FORMS_ONDELACTION."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
         break;
      }
      break;
  }

}
elseif ($TemplateID>0)
//     
{
  switch ($phase)
    {
      case 5:
      //   
      // Settings, Header, Footer, CustomSettings
        $res=check_eval($Settings,0);
        $status=$res?1:$status;
        $output.="<tr> <td>".CONTROL_TEMPLATE_TEPL_MENU."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
        $res=check_eval($Header,1);
        $status=$res?1:$status;
        $output.="<tr> <td>".CONTROL_TEMPLATE_TEPL_HEADER."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
        $res=check_eval($Footer,1);
        $status=$res?1:$status;
        $output.="<tr> <td>".CONTROL_TEMPLATE_TEPL_FOOTER."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
        $res=check_eval($CustomSettings,0);
        $status=$res?1:$status;
        $output.="<tr> <td>".CONTROL_TEMPLATE_CUSTOM_SETTINGS."</td><td>".($res?NETCAT_DEBUG_ERROR_INSTRING.$res:"")."</td> </tr>\n";
        break;
    }
}
$output.="</tbody></table>";
//echo stripslashes($Settings);
$output=str_replace(array("\r","\n"),array("",""), $output);
$json_answer=" { \"status\": \"".($status?"err":"ok")."\" , \"content\" : \"$output\" }; ";
echo $json_answer;


ob_flush();
?>
